
#include "../src/nemo/Vector.h"
#include "../src/nemo/Mapping.h"

#include <iostream>

using namespace std;
using namespace nemo;


int main(){
	RealVector x(1.0, 2.0, 3.0);
	cout << x << endl;

	// transform a vector in-place with some mapping that is applied component wise 
	x.transform( 1.0 / arg<double>() );
	cout << x << endl; // output: [1, 0.5, 0.333333]

	// create a new vector as result of a component wise operation
	RealVector y = x.map( arg<double>()+1.0 );
	cout << y << endl; // output: [2, 1.5, 1.33333]

 	// .. also with mixed-type mappings
	MathVector<bool> b = x.map( arg<double>() >= 0.5 );
	cout << b << endl; // output: [1, 1, 0]

}
