#ifndef _NEMO_CPP11_H_
#define _NEMO_CPP11_H_


#ifdef NEMO_HAS_CPP0x
	// general C++0x support

	#define _nemo_get_type_(expr) decltype(expr)

	// initializer lists
	#if (__GNUC__ > 5) || ((__GNUC__ >= 4) && (__GNUC_MINOR__ >= 4))
		#define _NEMO_HAS_INIT_LISTS_
	#endif

	// function template defaults
	#ifndef _WIN32
		// works for all somewhat c++0x compatible compilers except msvc ^^
		#define _NEMO_HAS_FUNCTION_TEMPLATE_DEFAULTS_
	#endif

#elif defined( __GNUC__ )
	// GCC fallbacks for absolutely necessary things
	
//#include <boost/typeof/typeof.hpp>
//#define _nemo_get_type_(expr) BOOST_TYPEOF_TPL(expr)
//  gives gcc error: error: ‘::mpl_’ has not been declared

//#define _nemo_get_type_(expr) typeof(expr)
// gives gcc error: sorry, unimplemented: mangling typeof, use decltype instead

	#define _nemo_get_type_(expr) __decltype(expr)

#else
	# error Cannot handle type information without enabling USE_CPP_0X or using GCC as compiler
#endif



#endif

