#ifndef _NEMO_ERRORS_H_
#define _NEMO_ERRORS_H_




#ifdef NEMO_ABORT_ON_ERROR
	#include <iostream>
	#define _NEMO_ARGUMENT_ERROR(message) \
		std::cerr << message << std::endl; \
		abort(); 
	#define _NEMO_LOGIC_ERROR(message) \
		std::cerr << message << std::endl; \
		abort(); 

#else
	#include <stdexcept>
	#define _NEMO_ARGUMENT_ERROR(message) \
		throw std::invalid_argument(message); 
	#define _NEMO_LOGIC_ERROR(message) \
		throw std::logic_error(message); 

#endif




#endif
