
#define BOOST_TEST_MODULE MathVectorIO
#include <boost/test/unit_test.hpp>

#include "../src/nemo/Vector.h"

#include <string>
#include <sstream>

// boost has non-virtual constructors ^^
#pragma GCC diagnostic ignored "-Weffc++"

using namespace nemo;
using namespace boost::unit_test;
using namespace std;


BOOST_AUTO_TEST_SUITE(MathVectorIO)


BOOST_AUTO_TEST_CASE(mathVectorOutStream){

	RealVector v0;
	stringstream s0;
	s0 << v0;
	BOOST_CHECK_EQUAL( s0.str(), string("[]") );

	RealVector v1(1.2);
	stringstream s1;
	s1 << v1;
	BOOST_CHECK_EQUAL( s1.str(), string("[1.2]") );
	
	RealVector v2(1.0, 2.0);
	stringstream s2;
	s2 << v2;
	BOOST_CHECK_EQUAL( s2.str(), string("[1, 2]") );

	
}


BOOST_AUTO_TEST_SUITE_END()

