
#include <iostream>


#include "Vector.h"

/* when compiling with NO_GCC_ADL_WORKAROUND, 
 * this example might not compile on GCC <= 4.4 if the following
 * statement in commented. Immediate construction of MathVector
 * with default-ctor seems to be a rather generic workaround,
 * but a very unconvenient one for users
 */
//nemo::RealVector fooVec;

namespace foo {

	class FOO {
	public:
		FOO(nemo::RealVector v) : value(v) {}
		nemo::RealVector get(){return value;}
		void set(nemo::RealVector v){this->value = v;}
	private:
		nemo::RealVector value;
	};
}


int main(){

	foo::FOO a(nemo::RealVector(nemo::dim(2)));
	std::cout << a.get() << std::endl;
	nemo::RealVector x(nemo::dim(3));
	a.set(x);
	std::cout << a.get() << std::endl;

}


