#include "Vector.h"
#include <iostream>



/* when compiling with NO_GCC_ADL_WORKAROUND, 
 * this example might only compile on GCC <= 4.4 if the following
 * definition of FOO is moved between Derived and main()
 */
class FOO {
public:
	FOO(nemo::RealVector v) : value(v) {}
	nemo::RealVector get(){return value;}
	void set(nemo::RealVector v){this->value = v;}
private:
	nemo::RealVector value;
};

class Base {
public:
	Base() : _foo() {
		this->_foo = nemo::RealVector(nemo::dim(14));
	}

	Base(nemo::RealVector fubar) :
	_foo(fubar) {
	}

	virtual ~Base(){}

	nemo::RealVector get(){return _foo;}
	void set(nemo::RealVector v){this->_foo = v;}
protected:
    	nemo::RealVector _foo;
};

class Derived: public Base {
public:
	Derived() : Base() {}

	Derived(nemo::RealVector fubar) : Base(fubar) {}

	Derived* fu(nemo::RealVector fubar) {
		return new Derived(fubar);
	}

};

int main() {
	nemo::RealVector v(nemo::dim(2));

	Base a1;
	std::cout << a1.get() << std::endl;
	Base *a2 = new Base(v);
	std::cout << a2->get() << std::endl;

	Derived b1;
	Derived b2(v);

	FOO b(nemo::RealVector(nemo::dim(2)));
	std::cout << b.get() << std::endl;

	nemo::RealVector y(nemo::dim(3));
	b.set(y);
}


